package pps.core.system.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.system.entity.SysInformTemplateReceiveTypeDetailEnt;
import pps.core.system.entity.SysInformTemplateReceiveTypeDetailView;
import pps.core.system.mapper.SysInformTemplateReceiveTypeDetailMapper;
import pps.core.system.mapper.SysInformTemplateReceiveTypeDetailViewMapper;
import pps.core.system.service.data.sys_inform_template_receive_type_detail.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;

import java.util.List;

@XService
public class SysInformTemplateReceiveTypeDetailService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSysInformTemplateReceiveTypeDetail(XContext context, CreateSysInformTemplateReceiveTypeDetailInput input) {
        SysInformTemplateReceiveTypeDetailMapper mapper = context.getBean(SysInformTemplateReceiveTypeDetailMapper.class);
        SysInformTemplateReceiveTypeDetailEnt entity = new SysInformTemplateReceiveTypeDetailEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSysInformTemplateReceiveTypeDetail(XContext context, UpdateSysInformTemplateReceiveTypeDetailInput input) {
        SysInformTemplateReceiveTypeDetailMapper mapper = context.getBean(SysInformTemplateReceiveTypeDetailMapper.class);
        QueryWrapper<SysInformTemplateReceiveTypeDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysInformTemplateReceiveTypeDetailEnt::getId, input.getId());
        SysInformTemplateReceiveTypeDetailEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSysInformTemplateReceiveTypeDetail(XContext context, DeleteSysInformTemplateReceiveTypeDetailInput input) {
        SysInformTemplateReceiveTypeDetailMapper mapper = context.getBean(SysInformTemplateReceiveTypeDetailMapper.class);
        QueryWrapper<SysInformTemplateReceiveTypeDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysInformTemplateReceiveTypeDetailEnt::getId, input.getId());
        SysInformTemplateReceiveTypeDetailEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSysInformTemplateReceiveTypeDetailOutput> getSysInformTemplateReceiveTypeDetail(XContext context, GetSysInformTemplateReceiveTypeDetailInput input) {
        SysInformTemplateReceiveTypeDetailMapper mapper = context.getBean(SysInformTemplateReceiveTypeDetailMapper.class);
        QueryWrapper<SysInformTemplateReceiveTypeDetailEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SysInformTemplateReceiveTypeDetailEnt::getId, input.getId());
        SysInformTemplateReceiveTypeDetailEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSysInformTemplateReceiveTypeDetailOutput output = new GetSysInformTemplateReceiveTypeDetailOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSysInformTemplateReceiveTypeDetailViewOutput> getSysInformTemplateReceiveTypeDetailView(XContext context, GetSysInformTemplateReceiveTypeDetailViewInput input) {
        SysInformTemplateReceiveTypeDetailViewMapper mapper = context.getBean(SysInformTemplateReceiveTypeDetailViewMapper.class);
        SysInformTemplateReceiveTypeDetailView record = new SysInformTemplateReceiveTypeDetailView();
        XCopyUtils.copyObject(input, record);
        SysInformTemplateReceiveTypeDetailView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSysInformTemplateReceiveTypeDetailViewOutput output = new GetSysInformTemplateReceiveTypeDetailViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySysInformTemplateReceiveTypeDetailViewOutput> querySysInformTemplateReceiveTypeDetailView(XContext context, QuerySysInformTemplateReceiveTypeDetailViewInput input) {
        SysInformTemplateReceiveTypeDetailViewMapper mapper = context.getBean(SysInformTemplateReceiveTypeDetailViewMapper.class);
        SysInformTemplateReceiveTypeDetailView record = new SysInformTemplateReceiveTypeDetailView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SysInformTemplateReceiveTypeDetailView> list = mapper.selectList(record);
        PageInfo<SysInformTemplateReceiveTypeDetailView> pageInfo = new PageInfo<>(list);
        List<QuerySysInformTemplateReceiveTypeDetailViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySysInformTemplateReceiveTypeDetailViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }
}